from LibGraphes import *

def main():
    g = { "a" : ["d"],
          "b" : ["c"],
          "c" : ["b", "d", "e"],
          "d" : ["a", "c"],
          "e" : ["c"],
          "f" : []
    }
    g2 = { "r3" : ["r1", "r2"],
           "r2" : ["r3", "r1", "c", "a"],
           "r1" : ["r3", "r2", "c"],
           "c"  : ["r1", "r2", "b", "a", "d", "e"],
           "b"  : ["a", "c", "d", "e"],
           "e"  : ["b", "c", "d"],
           "a"  : ["b", "c", "d", "r2"],
           "d"  : ["a", "b", "c", "e"]
    }

    g3 = { "1" : ["2"],
           "2" : ["1"],
           "3" : ["4"],
           "4" : ["3"],
           "5" : ["6","7","8"],
           "6" : ["5","7"],
           "7" : ["5","6"],
           "8" : ["5"],
           "9" : []
    }


    
    # graph = Graph(g)
    # graph2 = Graph(g2)

    graph3 = Graph(g3)

    graph3.print_dot('colorationg3.dot', graph3.color(3))

    """
    
    print("Vertices of graph:")
    print(graph.vertices())

    print("Edges of graph:")
    print(graph.edges())

    print("Add vertex:")
    graph.add_vertex("z")

    print("Vertices of graph:")
    print(graph.vertices())

    print("Add an edge:")
    graph.add_edge(("a","z"))

    print("Add an edge:")
    graph.add_edge(("a","a"))


    print("Vertices of graph:")
    print(graph.vertices())

    print("Edges of graph:")
    print(graph.edges())

    print('Adding an edge {"x","y"} with new vertices:')
    graph.add_edge({"x","y"})
    print("Vertices of graph:")
    print(graph.vertices())
    print("Edges of graph:")
    print(graph.edges())

    graph.print_dot('coloration.dot', graph.color(3))
    graph2.print_dot('g2.dot')
    graph2.print_dot('g2colore.dot', graph2.color(6))
"""

"""    graph.delete_vertex('c')
    graph.print_dot('apres1')
    graph.delete_edge(('d', 'a'))
    graph.print_dot('apres2')
"""


"""
>>> graph.dfs_traversal('a')
['a', 'z', 'd', 'c', 'e', 'b']
>>> graph.dfs_traversal('d')
['d', 'c', 'e', 'b', 'a', 'z']

>>> graph.bfs_traversal('d')
['d', 'a', 'c', 'z', 'b', 'e']
>>> graph.bfs_traversal('a')
['a', 'd', 'z', 'c', 'b', 'e']
"""

"""
>>> graph.color(0)
False
>>> graph.color(3)
{'a': 1, 'c': 1, 'b': 0, 'e': 0, 'd': 0, 'f': 0, 'y': 0, 'x': 1, 'z': 0}
"""

if __name__ == '__main__':
    main()
